#!/usr/bin/env python3

#XML generated with glade, see https://python-gtk-3-tutorial.readthedocs.io/en/latest/builder.html
window_xml = '''
<?xml version="1.0" encoding="UTF-8"?>
<!-- Generated with glade 3.40.0 -->
<interface>
  <requires lib="gtk+" version="3.24"/>
  <object class="GtkAdjustment" id="delay_adjuster">
    <property name="upper">1000</property>
    <property name="step-increment">10</property>
    <property name="page-increment">100</property>
    <signal name="value-changed" handler="delay_adjuster_value_changed_cb" swapped="no"/>
  </object>
  <object class="GtkAdjustment" id="messages_size_adjuster">
    <property name="lower">1</property>
    <property name="upper">1000</property>
    <property name="value">1</property>
    <property name="step-increment">10</property>
    <property name="page-increment">100</property>
    <signal name="value-changed" handler="messages_size_adjuster_value_changed_cb" swapped="no"/>
  </object>
  <object class="GtkWindow" id="producer_window">
    <property name="can-focus">False</property>
    <property name="title" translatable="yes">ASAPO Test Producer</property>
    <signal name="destroy" handler="producer_window_destroy_cb" swapped="no"/>
    <child>
      <!-- n-columns=2 n-rows=12 -->
      <object class="GtkGrid">
        <property name="visible">True</property>
        <property name="can-focus">False</property>
        <property name="margin-start">10</property>
        <property name="margin-end">10</property>
        <property name="margin-top">10</property>
        <property name="margin-bottom">10</property>
        <child>
          <object class="GtkLabel">
            <property name="visible">True</property>
            <property name="can-focus">False</property>
            <property name="halign">start</property>
            <property name="label" translatable="yes">ASAPO URL</property>
          </object>
          <packing>
            <property name="left-attach">0</property>
            <property name="top-attach">0</property>
          </packing>
        </child>
        <child>
          <object class="GtkLabel">
            <property name="visible">True</property>
            <property name="can-focus">False</property>
            <property name="halign">start</property>
            <property name="label" translatable="yes">ASAPO Secret</property>
          </object>
          <packing>
            <property name="left-attach">0</property>
            <property name="top-attach">1</property>
          </packing>
        </child>
        <child>
          <object class="GtkLabel">
            <property name="visible">True</property>
            <property name="can-focus">False</property>
            <property name="halign">start</property>
            <property name="label" translatable="yes">Beamtime</property>
          </object>
          <packing>
            <property name="left-attach">0</property>
            <property name="top-attach">2</property>
          </packing>
        </child>
        <child>
          <object class="GtkLabel">
            <property name="visible">True</property>
            <property name="can-focus">False</property>
            <property name="halign">start</property>
            <property name="label" translatable="yes">Source</property>
          </object>
          <packing>
            <property name="left-attach">0</property>
            <property name="top-attach">3</property>
          </packing>
        </child>
        <child>
          <object class="GtkLabel">
            <property name="visible">True</property>
            <property name="can-focus">False</property>
            <property name="halign">start</property>
            <property name="label" translatable="yes">In memory only</property>
          </object>
          <packing>
            <property name="left-attach">0</property>
            <property name="top-attach">7</property>
          </packing>
        </child>
        <child>
          <object class="GtkLabel">
            <property name="visible">True</property>
            <property name="can-focus">False</property>
            <property name="halign">start</property>
            <property name="label" translatable="yes">Delay ms</property>
          </object>
          <packing>
            <property name="left-attach">0</property>
            <property name="top-attach">8</property>
          </packing>
        </child>
        <child>
          <object class="GtkLabel">
            <property name="visible">True</property>
            <property name="can-focus">False</property>
            <property name="halign">start</property>
            <property name="label" translatable="yes">10*KBytes per message</property>
          </object>
          <packing>
            <property name="left-attach">0</property>
            <property name="top-attach">9</property>
          </packing>
        </child>
        <child>
          <object class="GtkEntry" id="url_edit">
            <property name="width-request">300</property>
            <property name="visible">True</property>
            <property name="can-focus">True</property>
            <property name="text" translatable="yes">localhost:8400</property>
          </object>
          <packing>
            <property name="left-attach">1</property>
            <property name="top-attach">0</property>
          </packing>
        </child>
        <child>
          <object class="GtkEntry" id="secret_edit">
            <property name="visible">True</property>
            <property name="can-focus">True</property>
            <property name="visibility">False</property>
            <property name="text" translatable="yes">veryverysecretkey</property>
          </object>
          <packing>
            <property name="left-attach">1</property>
            <property name="top-attach">1</property>
          </packing>
        </child>
        <child>
          <object class="GtkEntry" id="beamtime_edit">
            <property name="visible">True</property>
            <property name="can-focus">True</property>
            <property name="text" translatable="yes">asapo_test</property>
          </object>
          <packing>
            <property name="left-attach">1</property>
            <property name="top-attach">2</property>
          </packing>
        </child>
        <child>
          <object class="GtkEntry" id="source_edit">
            <property name="visible">True</property>
            <property name="can-focus">True</property>
            <property name="text" translatable="yes">test_source</property>
          </object>
          <packing>
            <property name="left-attach">1</property>
            <property name="top-attach">3</property>
          </packing>
        </child>
        <child>
          <object class="GtkSwitch" id="memory_switch">
            <property name="visible">True</property>
            <property name="can-focus">True</property>
            <property name="halign">start</property>
          </object>
          <packing>
            <property name="left-attach">1</property>
            <property name="top-attach">7</property>
          </packing>
        </child>
        <child>
          <object class="GtkScale">
            <property name="visible">True</property>
            <property name="can-focus">True</property>
            <property name="adjustment">delay_adjuster</property>
            <property name="fill-level">1000</property>
            <property name="round-digits">0</property>
            <property name="digits">0</property>
            <property name="value-pos">left</property>
          </object>
          <packing>
            <property name="left-attach">1</property>
            <property name="top-attach">8</property>
          </packing>
        </child>
        <child>
          <object class="GtkScale">
            <property name="visible">True</property>
            <property name="can-focus">True</property>
            <property name="adjustment">messages_size_adjuster</property>
            <property name="fill-level">1000</property>
            <property name="round-digits">0</property>
            <property name="digits">0</property>
            <property name="value-pos">left</property>
          </object>
          <packing>
            <property name="left-attach">1</property>
            <property name="top-attach">9</property>
          </packing>
        </child>
        <child>
          <object class="GtkButton" id="connect_button">
            <property name="label" translatable="yes">Connect</property>
            <property name="visible">True</property>
            <property name="can-focus">True</property>
            <property name="receives-default">True</property>
            <property name="halign">center</property>
            <signal name="clicked" handler="connect_button_clicked_cb" swapped="no"/>
          </object>
          <packing>
            <property name="left-attach">0</property>
            <property name="top-attach">10</property>
          </packing>
        </child>
        <child>
          <object class="GtkLabel" id="connected_label">
            <property name="visible">True</property>
            <property name="can-focus">False</property>
            <property name="label" translatable="yes">Not Connected</property>
          </object>
          <packing>
            <property name="left-attach">1</property>
            <property name="top-attach">10</property>
          </packing>
        </child>
        <child>
          <object class="GtkLabel">
            <property name="visible">True</property>
            <property name="can-focus">False</property>
            <property name="halign">start</property>
            <property name="label" translatable="yes">Stream</property>
          </object>
          <packing>
            <property name="left-attach">0</property>
            <property name="top-attach">4</property>
          </packing>
        </child>
        <child>
          <object class="GtkEntry" id="stream_edit">
            <property name="visible">True</property>
            <property name="can-focus">True</property>
            <property name="text" translatable="yes">default</property>
          </object>
          <packing>
            <property name="left-attach">1</property>
            <property name="top-attach">4</property>
          </packing>
        </child>
        <child>
          <object class="GtkToggleButton" id="run_button">
            <property name="label" translatable="yes">Run</property>
            <property name="visible">True</property>
            <property name="can-focus">True</property>
            <property name="receives-default">True</property>
            <property name="halign">center</property>
            <signal name="toggled" handler="run_button_toggled_cb" swapped="no"/>
          </object>
          <packing>
            <property name="left-attach">1</property>
            <property name="top-attach">11</property>
          </packing>
        </child>
        <child>
          <object class="GtkButton" id="delete_stream_button">
            <property name="label" translatable="yes">Delete Stream</property>
            <property name="visible">True</property>
            <property name="can-focus">True</property>
            <property name="receives-default">True</property>
            <property name="halign">center</property>
            <signal name="clicked" handler="delete_stream_button_clicked_cb" swapped="no"/>
          </object>
          <packing>
            <property name="left-attach">0</property>
            <property name="top-attach">11</property>
          </packing>
        </child>
        <child>
          <object class="GtkLabel">
            <property name="visible">True</property>
            <property name="can-focus">False</property>
            <property name="halign">start</property>
            <property name="label" translatable="yes">Pipeline Step</property>
          </object>
          <packing>
            <property name="left-attach">0</property>
            <property name="top-attach">6</property>
          </packing>
        </child>
        <child>
          <object class="GtkLabel">
            <property name="visible">True</property>
            <property name="can-focus">False</property>
            <property name="halign">start</property>
            <property name="label" translatable="yes">Instance Id</property>
          </object>
          <packing>
            <property name="left-attach">0</property>
            <property name="top-attach">5</property>
          </packing>
        </child>
        <child>
          <object class="GtkEntry" id="instance_id_edit">
            <property name="visible">True</property>
            <property name="can-focus">True</property>
            <property name="text" translatable="yes">auto</property>
          </object>
          <packing>
            <property name="left-attach">1</property>
            <property name="top-attach">5</property>
          </packing>
        </child>
        <child>
          <object class="GtkEntry" id="pipeline_step_edit">
            <property name="visible">True</property>
            <property name="can-focus">True</property>
            <property name="text" translatable="yes">auto</property>
          </object>
          <packing>
            <property name="left-attach">1</property>
            <property name="top-attach">6</property>
          </packing>
        </child>
      </object>
    </child>
  </object>
</interface>
'''

import gi

gi.require_version("Gtk", "3.0")

from gi.repository import GObject, Gtk, Gio
from random import randbytes
import asapo_producer
import jwt
import time

class WindowHandler(GObject.Object):
    def __init__(self, url, secret, beamtime, source, stream, inst_id, pipeline, inmem, connect):
        super().__init__()
        self.url = url
        self.secret = secret
        self.beamtime = beamtime
        self.source = source
        self.stream = stream
        self.inst_id = inst_id
        self.pipeline = pipeline
        self.inmem = inmem
        self.connect = connect
        self.cancel = None
        self.producer = None
        self.task = None
        self.delayms = 0
        self.size = 1
    def producer_window_destroy_cb(self, window):
        try:
            if (self.producer is not None):
                self.send_stop()
                self.producer.wait_requests_finished(2000)
        finally:
            Gtk.main_quit()
    def connect_button_clicked_cb(self, button):
        urltext = url.get_text()
        secrettext = secret.get_text()
        beamtimetext = beamtime.get_text()
        sourcetext = source.get_text()
        instidtext = self.inst_id.get_text()
        pipelinetext = self.pipeline.get_text()

        print("AUTH string: ",                                  jwt.encode({
                                   "exp": 9571710216,
                                   "jti": "c3iqaljf43alfp8rnkm0",
                                   "sub": "bt_"+beamtimetext,
                                   "ExtraClaims": {
                                     "AccessTypes": [
                                       "write",
                                       "read"
                                     ]
                                   }
                                 }, secrettext, algorithm="HS256"),)


        self.producer = asapo_producer.create_producer(urltext,
                                 'processed',
                                 beamtimetext,
                                 'auto',
                                 sourcetext,
                                 jwt.encode({
                                   "exp": 9571710216,
                                   "jti": "c3iqaljf43alfp8rnkm0",
                                   "sub": "bt_"+beamtimetext,
                                   "ExtraClaims": {
                                     "AccessTypes": [
                                       "write",
                                       "read"
                                     ]
                                   }
                                 }, secrettext, algorithm="HS256"),
                                 1,
                                 60000,
                                 instidtext,
                                 pipelinetext)
        button.set_sensitive(False)
        connect.set_text("Connected to: " + urltext)
    def delete_stream_button_clicked_cb(self, button):
        if (self.producer is not None):
            self.producer.delete_stream(stream = stream.get_text())
    def delay_adjuster_value_changed_cb(self, adjuster):
        self.delayms = adjuster.get_value()
    def messages_size_adjuster_value_changed_cb(self, adjuster):
        self.size = adjuster.get_value()
    def run_button_toggled_cb(self, toggle):
        if (toggle.get_active()):
            if (self.producer is None or self.task is not None):
                toggle.set_active(False)
                return
            self.send_start()
        else:
            self.send_stop()
    def send_start(self):
        self.cancel = Gio.Cancellable()
        self.task = Gio.Task.new(self, self.cancel, None, None)
        self.streamtxt = self.stream.get_text()
        self.inmemory = self.inmem.get_active()
        self.task.run_in_thread(self.send)
    def send_stop(self):
        if self.cancel is not None:
            print ("cancelling")
            self.cancel.cancel()
            self.task = None
    def send(self, task, source_object, task_data, cancellable):
        i = 0
        while not cancellable.is_cancelled():
            i+=1
            self.producer.send(0, "processed/who_cares"+str(i), randbytes(int(self.size * 10000)), stream = self.streamtxt, ingest_mode = asapo_producer.CACHE_ONLY_INGEST_MODE if self.inmemory else asapo_producer.DEFAULT_INGEST_MODE, callback=callback, auto_id=True)
            self.connect.set_text("Sent Message: " + str(i))
            time.sleep(self.delayms / 1000.0)
        self.connect.set_text("Last Sent Message: " + str(i))

def callback(payload, err):
    pass

builder = Gtk.Builder()
builder.add_from_string(window_xml)
win = builder.get_object("producer_window")
url = builder.get_object("url_edit")
secret = builder.get_object("secret_edit")
beamtime = builder.get_object("beamtime_edit")
source = builder.get_object("source_edit")
stream = builder.get_object("stream_edit")
inst_id = builder.get_object("instance_id_edit")
pipeline = builder.get_object("pipeline_step_edit")
inmem = builder.get_object("memory_switch")
connect = builder.get_object("connected_label")
builder.connect_signals(WindowHandler(url, secret, beamtime, source, stream, inst_id, pipeline, inmem, connect))
win.show_all()
Gtk.main()
